alias memos { if ($dialog(memoserv) == $null) { dialog -mdo memoserv memoserv } }

dialog memoserv {
  title "Memoserv"
  size -1 -1 400 300

  box "Send",100,10 5 380 120
  text "Send To:",101,20 25 50 13,right
  edit "",102,75 22 165 22,autohs
  text "Memo:",103,20 55 50 13,right
  edit "",104,75 52 305 63,multi vsbar
  button "Send",105,250 23 60 20
  button "Send SOP",106,320 23 60 20

  box "Read",200,10 130 380 140
  text "Memos:",201,20 150 50 13,right
  combo 202,75 147 235 200,drop vsbar
  button "List",203,320 148 60 20
  text "Memo:",204,20 180 50 13,right
  edit "",205,75 177 235 83,read vsbar multi
  button "Delete",206,320 178 60 20
  button "Undelete",207,320 208 60 20
  button "Purge",208,320 238 60 20

  button "Forwarding",300,250 277 120 20
  check "Show Deleted Memos",301,30 277 130 20,left

  button "Cancel", 500, -1 -1 -1 -1, cancel
}

dialog memoserv.forward {
  title "Memoserv"
  size -1 -1 200 120

  check "Foward Memos",10,10 10 140 13,left disable
  box "Forward To",11,10 30 180 80,disable
  text "Nick:",12,20 50 50 13,right disable
  edit "",13,80 47 100 22,autohs disable
  text "Password:",14,20 80 50 13,right disable
  edit "",15,80 77 100 22,autohs pass disable

  button "Cancel", 500, -1 -1 -1 -1, cancel
}

alias memoserv.notice {
  if ($dialog(memoserv) == $null) { echo.notice -MemoServ- $1- | return }

  ;handle list
  if (End of memo list. == $1-) {
    if (%memoserv.list.new) { did -i memoserv 202 1 <New Memos> }
    else { memoserv read 1 }
    did -c memoserv 202 1
    unset %memoserv.list*
  }
  elseif (%memoserv.list) {
    did -a memoserv 202 $1-
    if ($left($1,1) == *) { set %memoserv.list.new $true }
  }
  elseif (Memo list for * To read, use: * read <number> iswm $1-) { did -r memoserv 202 | set %memoserv.list $true }
  elseif (You have no memos. == $1-) { did -r memoserv 202 | did -a memoserv 202 <No Memos> | did -c memoserv 202 1 }

  ;handle read
  elseif (%memoserv.read) {
    did -r memoserv 205
    did -a memoserv 205 $1-
    unset %memoserv.read
  }
  elseif ( (Memo * from * To delete, use: * del * iswm $1-) || (Memo * from * be deleted automatically* iswm $1-) ) {
    if ($did(memoserv,202,1).text == <New Memos>) { did -d memoserv 202 1 }
    var %memoNumber = $2
    set %memoserv.read $true
    tokenize 32 $did(memoserv,202,%memoNumber).text
    if ($left($1,1) != D) {
      did -o memoserv 202 %memoNumber %memoNumber $2-
      did -c memoserv 202 %memoNumber
    }
  }

  ;handle delete/purge
  elseif (Memo * has been marked as deleted. iswm $1-) {
    var %memoNumber = $2
    tokenize 32 $did(memoserv,202,%memoNumber).text
    did -o memoserv 202 %memoNumber D $+ %memoNumber $2-
    did -c memoserv 202 %memoNumber
  }
  elseif (Memo * has been marked as undeleted. iswm $1-) {
    var %memoNumber = $2
    tokenize 32 $did(memoserv,202,%memoNumber).text
    did -o memoserv 202 %memoNumber $iif($1 isnum,$1,$right($1,-1)) $2-
    did -c memoserv 202 %memoNumber
  }
  elseif (Purged * memos from your account. iswm $1-) {
    var %i = 1
    while ($did(memoserv,202,%i).text) {
      tokenize 32 $ifmatch
      if ($left($1,1) == D) { did -d memoserv 202 %i }
      else { did -o memoserv 202 %i $iif($left($1,1) == *,* [ $+ [ %i ] ] ,%i) $2- | inc %i }
    }
    if ($did(memoserv,202).lines != 0) { did -c memoserv 202 1 | memoserv read 1 }
    else { did -a memoserv 202 <No Memos> }
    did -r memoserv 205
  }

  ;New messages, get the list
  elseif (New memo from *. For more information, use: * list iswm $1-) { memoserv list }

  elseif ( (Memo forwarding has not been setup for * iswm $1-) && ($dialog(memoserv.forward)) ) {
    did -e memoserv.forward 10,11,12,13,14,15
    did -n memoserv.forward 13,15
  }
  elseif ( ( (Memo forwarding is already disabled for * iswm $1-) || (Memo forwarding for * has been disabled. iswm $1-) ) && ($dialog(memoserv.forward)) ) {
    did -e memoserv.forward 10,11,12,13,14,15
    did -nr memoserv.forward 13,15
  }
  elseif ( (Memos sent to * are now being forwarded to * iswm $1-) && ($dialog(memoserv.forward)) ) {
    did -e memoserv.forward 10,11,12,13,14,15
    did -n memoserv.forward 13,15
    did -ra memoserv.forward 13 $strip($10)
  }
  elseif ( (Memos sent to * are forwarded to * iswm $1-) && ($dialog(memoserv.forward)) ) {
    did -e memoserv.forward 10,11,12,13,14,15
    did -n memoserv.forward 13,15
    did -ra memoserv.forward 13 $strip($8)
  }
  else { echo.notice -memoserv- $1- }
}

on *:dialog:memoserv:init:0:{ if ($server) { memoserv list } }

;send memos
on *:dialog:memoserv:sclick:105:{
  var %msg, %i

  if (($did(102).text) && ($did(104).text) && ($server)) {

    %i = 1
    while ($did(104,%i).text) { %msg = %msg $ifmatch | inc %i }

    memoserv send $did(102).text %msg
  }
  else { beep }
}
on *:dialog:memoserv:sclick:106:{
  if ((#* iswm $did(102).text) && ($did(104).text) && ($server)) { memoserv sendsop $did(102).text $did(104).text }
  else { beep }
}

;get memos
on *:dialog:memoserv:sclick:202:{
  tokenize 32 $did(202,$did(202).sel).text
  if ( ($1- == <No Memos>) || ($1- == <New Memos>) ) { return }
  if ($1 !isnum) { tokenize 32 $right($1,-1) }
  memoserv read $1
  did -r memoserv 205
}

;get list
on *:dialog:memoserv:sclick:203:{ memoserv list }

;delete/purge
on *:dialog:memoserv:sclick:206:{ memoserv del $iif($did(202,1).text == <New Memos>,$calc($did(202).sel -1),$did(202).sel) }
on *:dialog:memoserv:sclick:207:{ memoserv undel $iif($did(202,1).text == <New Memos>,$calc($did(202).sel -1),$did(202).sel) }
on *:dialog:memoserv:sclick:208:{ .timer 1 0 if ($?!="Are you sure you want to remove all messages marked as deleted?") { memoserv purge } }

;open forwarding dialog
on *:dialog:memoserv:sclick:300:{ dialog -m memoserv.forward memoserv.forward }

on *:dialog:memoserv.forward:init:0:{ if ($server) { memoserv forward } }

;turn forwarding on/off
on *:dialog:memoserv.forward:sclick:10:{
  if ($did(10).state) {
    if (($did(13).text) && ($did(15).text) && ($did(10).state)) { memoserv forward $did(13).text $did(15).text }
    else { did -u memoserv.forward 10 | beep }
  }
  else { memoserv forward - }
}

;Hotlink, double click on a memoserv message to open the memos dialog
on ^*:hotlink:*-memoserv-*:*:{
  return
}
on *:hotlink:*memoserv*:*:{ memos }
